package com.sky.ioc.job;

import com.sky.ioc.service.parking.ParkService;
import com.sky.ioc.service.meeting.MeetingRecordService;
import lombok.extern.slf4j.Slf4j;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;

@Slf4j
public class MeetingRecordJob implements Job {

    @Autowired
    MeetingRecordService recordService;

    @Autowired
    ParkService parkService;

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        log.info(String.format("同步会议数据!  时间:" + new Date()));
        recordService.getMeetingRecordList();
        log.info(String.format("同步停车数据!  时间:" + new Date()));
        parkService.getParkData();
    }
}
